#/function terra_system:items/misc/torch/give
#Created by Mithey

#PARAMETERS:
#Amount Temp - How many items to give
#Method Temp - What method the item should take to generate - default = give, 1 = summon, 2 = data merge
#DontDisplayMessage Temp - Don't display obtained message
#MessageMethod Temp - What method to display message to player - default = chat, 1 = actionbar
#CustomName Temp - Makes item show name
#Invulnerable Temp - Makes item Invulnerable
#NoGravity Temp - Makes item NoGravity
#PickupDelay Temp - Makes item have a custom PickupDelay
#Age Temp - Makes item have a custom Age
#FunctionPickup Temp - If item should use the custom pickup function

function terra_system:items/on_give1

#Give item
execute unless score Method Temp matches 1.. run give @s minecraft:torch{display:{Name:'{"translate":"terra.items.torch","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.torch.lore1","color":"gray","italic":true}']},RepairCost:100,HideFlags:16,CanPlaceOn:["#all_blocks"],ItemTags:["Torch","Item_MiscTorch"]}

#Summon item
execute if score Method Temp matches 1 run summon minecraft:item ~ ~ ~ {Item:{id:"minecraft:torch",Count:1b,tag:{display:{Name:'{"translate":"terra.items.torch","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.torch.lore1","color":"gray","italic":true}']},RepairCost:100,HideFlags:16,CanPlaceOn:["#all_blocks"],ItemTags:["Torch","Item_MiscTorch"]}},Tags:["TempNewItem"]}

#Data merge item
execute if score Method Temp matches 2 run data merge entity @s {Item:{id:"minecraft:torch",Count:1b,tag:{display:{Name:'{"translate":"terra.items.torch","bold":true}',Lore:['{"translate":""}','{"translate":"terra.items.torch.lore1","color":"gray","italic":true}']},RepairCost:100,HideFlags:16,CanPlaceOn:["#all_blocks"],ItemTags:["Torch","Item_MiscTorch"]}}}
execute if score Method Temp matches 2 run tag @s add TempNewItem

#Set properties
function terra_system:items/on_give2
execute if score CustomName Temp matches 1..2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {CustomName:'{"translate":"terra.items.torch","color":"white"}',CustomNameVisible:1}
execute if score FunctionPickup Temp matches 1 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionGlobal","FunctionGlobalItem","Item_MiscTorch"]}
execute if score FunctionPickup Temp matches 2 run data merge entity @e[tag=TempNewItem,limit=1,sort=nearest] {PickupDelay:32767,Age:-32768,Tags:["Function","FunctionItem","Item_MiscTorch"]}
tag @e remove TempNewItem

#Display message
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute unless score MessageMethod Temp matches 1.. run tellraw @s {"translate":"","extra":[{"score":{"name":"Amount","objective":"Temp"}},{"translate":"x ["},{"translate":"terra.items.torch","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.obtained"}]}
execute unless score LoopStarted Temp matches 1 unless score DontDisplayMessage Temp matches 1 run execute if score MessageMethod Temp matches 1 run title @s actionbar {"translate":"","extra":[{"score":{"name":"Amount","objective":"Temp"}},{"translate":"x ["},{"translate":"terra.items.torch","color":"white","bold":true},{"translate":"] "},{"translate":"terra.items.obtained"}]}

#Run function again if still need to give more
scoreboard players set LoopStarted Temp 1
scoreboard players remove Amount Temp 1
execute unless score Method Temp matches 1.. run execute if score Amount Temp matches 1.. run function terra_system:items/misc/torch/give

function terra_system:items/on_give3






